#ifndef MENUV3
#define MENUV3

typedef char MenuText[80];

typedef struct MenuItemStruct
{
    MenuText text;
    struct MenuItemStruct *next;
    struct MenuItemStruct *subItem;
} MenuItem;

typedef struct UserChoiceStruct
{
    int choiceId;
    MenuItem *item;
    struct UserChoiceStruct *next;
} UserChoice;

#endif

//MenuItem

MenuItem* newMenuItem(MenuText text);
void destroyMenuItem(MenuItem *item);

void appendItem(MenuItem *menu, MenuItem *toAppend);
void insertBeforeItem(MenuItem *menu, MenuItem *reference, MenuItem *toInsertBefore);
void appendSubItem(MenuItem *menu, MenuItem *toAppend);
void insertBeforeSubItem(MenuItem *menu, MenuItem *reference, MenuItem *toInsertBefore);

int itemCount(MenuItem *item);
int subItemCount(MenuItem *item);

UserChoice* showMenu(MenuItem *menu, char title[]);


//UserChoice
UserChoice* newUserChoice(int choiceId, MenuItem *item);
void destroyUserChoice(UserChoice *choice);
void appendChoice(UserChoice *choice, UserChoice *toAppend);

//Test
void testMenuV3();
